#version 150

uniform	sampler2D	tex_out0;
uniform	sampler2D	tex_out1;
uniform	sampler2D	tex_out2;
uniform sampler2D	tex_out3;

uniform sampler2D	tex_point_light;
uniform sampler2D	tex_ssao;
uniform	sampler2D	tex_shadow;

uniform int			level;

in	vec2	p_tex_coord;

out vec4	out_color;

void main()
{
	if(level == 4) {
		vec3 color = texture2D(tex_out0, p_tex_coord).rgb;
		vec3 ssao = texture2D(tex_ssao, p_tex_coord).rgb;

		out_color = vec4(color - ssao, 1);
	} else if(level == 5) {
		if (p_tex_coord.x > 0.25 && p_tex_coord.x < 0.75 && p_tex_coord.y > 0.25 && p_tex_coord.y < 0.75)
			out_color = vec4(texture2D(tex_out0, p_tex_coord).xyz, 1);
		else if(p_tex_coord.x < 0.33 && p_tex_coord.y >= 0.5)
			out_color = vec4(texture2D(tex_out0, p_tex_coord).aaa, 1);
		else if(p_tex_coord.x < 0.66 && p_tex_coord.y >= 0.5)
			out_color = vec4(texture2D(tex_out1, p_tex_coord).aaa, 1);
		else if(p_tex_coord.x >= 0.66 && p_tex_coord.y >= 0.5)
			out_color = vec4(texture2D(tex_out2, p_tex_coord).aaa, 1);
		else if(p_tex_coord.x < 0.33 && p_tex_coord.y < 0.5)
			out_color = vec4(texture2D(tex_out1, p_tex_coord).rgb, 1);
		else if(p_tex_coord.x < 0.66 && p_tex_coord.y < 0.5)
			out_color = vec4(vec3(1) - texture2D(tex_ssao, p_tex_coord).rgb, 1);
		else if(p_tex_coord.x >= 0.66 && p_tex_coord.y < 0.5)
			out_color = vec4(texture2D(tex_out2, p_tex_coord).rgb * vec3(1.0/1280.0, 1.0/720.0, 1.0/1000.0), 1);
	} else {
		vec4 out0	= texture(tex_out0, p_tex_coord);
		vec4 lights = texture(tex_out3, p_tex_coord);
		vec3 ssao = texture(tex_ssao, p_tex_coord).rrr;

		vec4 lighting = texture2D(tex_point_light, p_tex_coord);
	
		vec3 color;
		// Compute final color
		if (lights.a > 0)
			color = lights.rgb;
		else
			color = vec3(0.15) * out0.rgb + (out0.rgb - ssao) * lighting.rgb + out0.rgb * lighting.aaa;//(out0.rgb * min(vec3(0.25) + lighting.rgb, 1.0) + lighting.aaa) - ssao.rrr;

		out_color = vec4(color, 1);
	}
}