#version 150

uniform mat4	vp_matrix;
uniform mat4	view_matrix;
uniform mat4	model_matrix;

uniform vec3	view_position;

in	vec4 in_vertex;
in  vec3 in_normal;
in  vec2 in_texcoord;

out vec3 view_space_position;
out vec3 view_space_normal;
out vec3 world_space_position;

out	vec2 texture_coordinate;

out mat3 normal_matrix;

void main(void)
{
	// Pass through the texture coordinate
	texture_coordinate = in_texcoord;
		
	// Calculate the view space position and normal
	normal_matrix = transpose(inverse(mat3(view_matrix * model_matrix)));

	view_space_position = (view_matrix * model_matrix * in_vertex).xyz;
	view_space_normal = normal_matrix * in_normal;

	world_space_position = (model_matrix * in_vertex).xyz;

	// Calculate the position in clip space
	gl_Position = vp_matrix * model_matrix * in_vertex;
}