#version 150

uniform int level;

uniform sampler2D tex_material_diffuse;
uniform vec4	material_color;

const vec3 light_position = vec3(1.0);
const vec3 ambient_color = vec3(0.25);

in	vec3 normal_vector;
in	vec2 tex_coord;

out vec4 out0;

void main() {
	if (level == 1) {
		out0 = vec4(1.0);
	} else if (level == 2) {
		vec3 light_vector = normalize(light_position);
		float NdotL = max(0.0, dot(normalize(light_vector), normalize(normal_vector)));
		out0 = vec4(NdotL * material_color.rgb + ambient_color, 1.0);
	} else if (level == 3) {
		out0 = texture2D(tex_material_diffuse, tex_coord);
	}
}