#version 150

uniform mat4	vp_matrix;
uniform mat4	model_matrix;
uniform mat4	view_matrix;

const vec3 light_position = vec3(10000.0);
const vec3 ambient_color = vec3(0.5);

in	vec4 in_vertex;
in  vec3 in_normal;
in  vec2 in_texcoord;

out	vec2	tex_coord;
out	vec3 normal_vector;

void main()
{
	tex_coord = in_texcoord;
	normal_vector = normalize((model_matrix * vec4(in_normal, 1)).xyz);

	gl_Position = vp_matrix * model_matrix * in_vertex;
}