#version 150

uniform mat4	model_matrix;
uniform mat4	view_matrix;
uniform mat4	vp_matrix;

uniform vec3	light_position;			// Position of the light

in	vec4	in_vertex;

out	vec4	screen_position;
out	vec3	light_position_view;

void main()
{
	light_position_view = (view_matrix * vec4(light_position, 1)).xyz;
	screen_position = vp_matrix * model_matrix * in_vertex;
	gl_Position = screen_position;
}