#version 150

uniform mat4	mvp_matrix;
uniform mat4	mv_matrix;
uniform mat4	model_matrix;

uniform vec3	view_position;

in	vec4 in_vertex;
in  vec3 in_normal;
in  vec2 in_textureCoordinate;

out vec3 view_space_position;
out vec3 view_space_normal;

out vec4 world_position;
out	vec2 texture_coordinate;
out	vec3 view_vector;

void main(void)
{
	// Pass through the texture coordinate
	texture_coordinate = in_textureCoordinate;
		
	// Calculate the view space position and normal
	view_space_position = (mv_matrix * in_vertex).xyz;
	view_space_normal	= (mv_matrix * vec4(in_normal, 0)).xyz;

	// Calculate the view vector
	world_position = model_matrix * in_vertex;
	view_vector = view_position - world_position.xyz;

	// Calculate the position in clip space
	gl_Position = mvp_matrix * in_vertex;
}