#version 150

// Light source components
uniform vec3  s_color;   // Color
uniform vec3  s_pos;     // Position
uniform float s_radius;  // Radius

// Geometry components
in      vec4  p;         // Position
in      vec3  n;         // Surface normal

// Material components
uniform vec3  m_diff;    // Diffuse
uniform vec3  m_spec;    // Specular
uniform vec3  m_shi;     // Shininess

out vec4 out_color;

void main()
{
    
    vec3 l = s_pos - p.xyz;     // light vector
    vec3 v = normalize(p.xyz);  // view vector
    vec3 h = normalize(v + l);  // half vector
    
    // attenuation
    float attenuation = clamp(1.0 - length(l)/s_radius, 0.0, 1.0);
    
    // diffuse and specular terms
    //float Idiff = clamp(dot(l, n) * m_diff * s_color, 0.0, 1.0);
    //float Ispec = pow(clamp(dot(h, n), 0.0, 1.0), m_shi) * m_spec * s_color;
                      
    // final color
    out_color = vec4(1.0); //(attenuation * (Idiff + Ispec), 1.0);
    
}