#version 150

uniform mat4 projection_matrix;
uniform mat4 view_matrix;
uniform mat4 model_matrix;

uniform mat3 normal_matrix;

in      vec4 in_vertex;
in      vec3 in_normal;
in      vec2 in_textureCoordinate;

out     vec4 p;
out     vec3 n;

void main(void)
{
    
    // Calculate position
    p = projection_matrix * view_matrix * model_matrix * in_vertex;
    
    // Calculate normal
    n = normal_matrix * in_normal;
    
    // Output to graphics card
    gl_Position = p;
    
}